﻿local broker = LibStub("LibDataBroker-1.1")

local PvP = broker:NewDataObject("Broker_PvP", {icon = "Interface\\PVPFrame\\\PVP-ArenaPoints-Icon", label = "PvP"})
LibStub("AceEvent-3.0"):Embed(PvP)

local onUpdateFrame = CreateFrame("Frame")
onUpdateFrame:Hide()

function PvP:Update()
	local status, queued, confirm, active
	self.status = nil
	
	for i=1, MAX_BATTLEFIELD_QUEUES do
		status = GetBattlefieldStatus(i)
		if ( status ~= "none" ) then
			if ( status == "queued" ) then
				queued = true
			elseif ( status == "confirm" ) then
				confirm = true
			elseif ( status == "active" ) then
				self.status = true
			end
		end
	end
	if confirm then
		self.text = "Confirm"
	elseif queued then
		self.text = "Queued"
	elseif self.status then
		self.text = "Active"
	else
		self.text = "No Queue"
	end
end

function PvP.OnClick(frame, button)
	GameTooltip:Hide()
	if ( PvP.status ) then
		if ( button == "RightButton" ) then
			ToggleDropDownMenu(1, nil, MiniMapBattlefieldDropDown, frame)
		elseif ( IsShiftKeyDown() ) then
			ToggleBattlefieldMinimap()
		else
			ToggleWorldStateScoreFrame()
		end
	elseif ( button == "RightButton" ) then
		ToggleDropDownMenu(1, nil, MiniMapBattlefieldDropDown, frame)
	end
end

function PvP:UPDATE_BATTLEFIELD_STATUS()
	self:Update()
	if MiniMapBattlefieldFrame:IsVisible() then
		MiniMapBattlefieldFrame:Hide()
	end
end

local time = 0
local function onUpdate()
	local nowint = floor(GetTime() * 11)
	if nowint > time + 10 then
		BattlefieldFrame_UpdateStatus(1)
		if (MiniMapBattlefieldFrame.tooltip) then
			PvP.tooltiptext = MiniMapBattlefieldFrame.tooltip
		else
			PvP.tooltiptext = "No Queues"
		end
		time = nowint
	end
end

onUpdateFrame:SetScript("OnUpdate",onUpdate)
onUpdateFrame:Show()
PvP:RegisterEvent("UPDATE_BATTLEFIELD_STATUS")
PvP:Update()